/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"


#include <stdio.h>
#include <string.h>                         /* strstr() */
#include <stdlib.h>                         /* free() exit() */
#include "../../src/initng_handler.h"
#include "../../src/initng_global.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_common.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_load_module.h"

#include "initng_interactive.h"

static int active;

/* Ask for every service if it shud start */
int check_interactive(active_h * service, e_a_status status)
{
    char asw[10];

    asw[0] = '\0';
    switch (status)
    {
        case STARTING:

            fprintf(stderr, "Start service %s, (Y/n/a):", service->name);
            fgets(asw, 9, stdin);
            /* if it is true, then its ok to launch service */
            if (asw[0] == 'y' || asw[0] == 'Y')
                return (TRUE);

            if (asw[0] == 'a' || asw[0] == 'A')
            {
                initng_unload_module_named("interactive");
                return (TRUE);
            }

            mark_service(service, FAIL_STARTING);
            return (FALSE);

        case STOP_MARKED:

            fprintf(stderr, "Stop service %s, (Y/n/a):", service->name);
            fgets(asw, 9, stdin);
            if (asw[0] == 'y' || asw[0] == 'Y')
                return (TRUE);

            if (asw[0] == 'a' || asw[0] == 'A')
                initng_unload_module_named("interactive");

            mark_service(service, FAIL_STOPPING);
            return (FALSE);
        default:
            break;
    }

    /* go ahead with the status change by default */
    return (TRUE);

}


int module_init(const char *version)
{
    int i;

    if (strcmp(version, INITNG_VERSION) != 0)
    {
        F_("This module, is compiled for \"%s\" version, and initng is compiled on \"%s\" version, wont load this module!\n", INITNG_VERSION, version);
        return (FALSE);
    }
    D_("module_init();\n");
    for (i = 0; g.Argv[i]; i++)
        if (strstr(g.Argv[i], "interactive"))
        {
            P_("Initng is started in interactive mode!\n");
            initng_add_hook(CONFIRM_ASTATUS_CHANGE, 30, &check_interactive);
            active = TRUE;
            return (TRUE);
        }

    active = FALSE;
    initng_unload_module_named("interactive");
    return (TRUE);
}

void module_unload(void)
{
    D_("module_unload();\n");
    if (active == TRUE)
        initng_del_hook(CONFIRM_ASTATUS_CHANGE, &check_interactive);
}
