/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"


#include <stdio.h>
#include <stdlib.h>                         /* free() exit() */
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include "../../src/initng_handler.h"
#include "../../src/initng_global.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_common.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_static_data_id.h"

#include "initng_netprobe.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/ip.h>
#include <netinet/in.h>
#include <net/if.h>
#include <string.h>
#include <arpa/inet.h>

static int is_network(void);


static int is_network(void)
{
    struct ifconf ifc;
    struct ifreq *ifr;
    char buffert[1024];
    int netsock = -1;


    netsock = socket(PF_INET, SOCK_DGRAM, IPPROTO_IP);
    if (netsock < 0)
    {
        F_("Unable to open a socket!\n");
        return (FALSE);
    }

    ifc.ifc_len = sizeof(buffert);
    ifc.ifc_buf = buffert;

    if (ioctl(netsock, SIOCGIFCONF, &ifc) < 0)
    {
        F_("error: SIOCGIFCONF\n");
        return (FALSE);
    }

    /*printf("len:%i\n", ifc.ifc_len); */


    ifr = ifc.ifc_req;

    {
        int i;
        for (i = ifc.ifc_len / sizeof(struct ifreq); --i >= 0; ifr++)
        {
            /* Loopback is not network */
            if (strcmp("lo", ifr->ifr_name) == 0)
                continue;
            /*struct ifreq i; */
            D_("found up interface %s.\n", ifr->ifr_name);
            close(netsock);
            return (TRUE);
        }

    }

    close(netsock);
    return (FALSE);
}

s_entry REQUIRE_NETWORK = { "require_network", SET, 15, STD_OPT };

static int check_network(active_h * service, e_a_status status)
{
    S_;

    /* only check START_DEP_MET */
    if (status != START_DEP_MET)
        return (TRUE);

    if (active_db_is(&REQUIRE_NETWORK, service))
    {
        if (is_network() == TRUE)
            return (TRUE);

        /* this will make this check again in one second */
        alarm(1);
        return (FALSE);
    }

    return (TRUE);
}


int module_init(const char *version)
{
    S_;
    if (strcmp(version, INITNG_VERSION) != 0)
    {
        F_("This module, is compiled for \"%s\" version, and initng is compiled on \"%s\" version, wont load this module!\n", INITNG_VERSION, version);
        return (FALSE);
    }

    initng_sdt_add(&REQUIRE_NETWORK);
    initng_add_hook(CONFIRM_ASTATUS_CHANGE, 55, &check_network);
    return (TRUE);
}

void module_unload(void)
{
    S_;
    initng_sdt_del(&REQUIRE_NETWORK);
    initng_del_hook(CONFIRM_ASTATUS_CHANGE, &check_network);
}
