
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"
#include "initng_active_status.h"




/* returns a string with status name for nice output */
const char *active_db_get_status_string(e_a_status status)
{
    switch (status)
    {
        case NONE:
            return ("NONE");
        case LOADING:
            return ("LOADING");
        case STARTING:
            return ("STARTING");
        case WAITING_FOR_START_DEP:
            return ("WAITING_FOR_START_DEP");
        case START_DEP_MET:
            return ("START_DEP_MET");
        case FAIL_STARTING:
            return ("FAIL_STARTING");
        case START_DEP_FAILED:
            return ("START_DEP_FAILED");
        case RUNNING:
            return ("RUNNING");
        case DONE:
            return ("DONE");
        case STOPPING:
            return ("STOPPING");
        case WAITING_FOR_STOP_DEP:
            return ("WAITING_FOR_STOP_DEP");
        case STOP_DEP_MET:
            return ("STOP_DEP_MET");
        case STOP_DEP_FAILED:
            return ("STOP_DEP_FAILED");
        case FAIL_STOPPING:
            return ("FAIL_STOPPING");
        case STOPPED:
            return ("STOPPED");
        case STOP_MARKED:
            return ("STOP_MARKED");
        case FREEING:
            return ("FREEING");
    }
    return (NULL);
}
