
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"

#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <alloca.h>
#include <assert.h>
#include "initng_process_db.h"
#include "initng_toolbox.h"

/* creates a process_h struct with defaults */
process_h *process_db_new(e_pt type)
{
    process_h *new_p = NULL;

    /* allocate a new process entry */
    new_p = (process_h *) initng_calloc(1, sizeof(process_h));  /* Allocate memory for a new process */
    if (!new_p)
    {
        F_("Unable to allocate process!\n");
        return (NULL);
    }

    new_p->pt = type;

    /* null pid */
    new_p->pid = 0;

    /* reset returncode */
    /* XXX: magic number - what does it mean? */
    new_p->r_code = -10;

    /* return new process_h pointer */
    return (new_p);
}

/* function to free a process_h struct */
void process_db_free(process_h * free_this)
{
    assert(free_this);

    if (free_this->out_pipe[0] > 0)
        close(free_this->out_pipe[0]);
    if (free_this->out_pipe[1] > 0)
        close(free_this->out_pipe[1]);
    if (free_this->buffer)
        free(free_this->buffer);

    free(free_this);
    return;
}
